var FdPrefs = {
  prefs: Components.classes["@mozilla.org/preferences-service;1"]
         .getService(Components.interfaces.nsIPrefService)
         .getBranch("extensions.fastdial."),

  encode: function(string) {
    return string ? encodeURIComponent(string) : "";
  },

  decode: function(string) {
    return string ? decodeURIComponent(string) : "";
  },

  createPageInfo: function(id, url, title) {
    return { id: id,
             url: url || "",
             title: title || "",
             refreshOnVisit: false,
             refresh: 0,
             customImage: null,
             customBackground: null,
             openIn: "", };
  },

  getPageInfo: function(id) {
    var pageInfo = this.createPageInfo(id);
    try {
      pageInfo = eval(this.prefs.getCharPref(id));
      pageInfo.id = id;
      pageInfo.title = this.decode(pageInfo.title);
      pageInfo.refresh = parseInt(pageInfo.refresh) > 0 ? pageInfo.refresh : 0;
      pageInfo.customImage = this.decode(pageInfo.customImage);
      if (!pageInfo.customBackground ||
          pageInfo.customBackground == "undefined") pageInfo.customBackground = ""; // legacy suppport
      if (!pageInfo.openIn || pageInfo.openIn == "undefined") pageInfo.openIn = ""; // legacy suppport
    }
    catch(e) {}

    return pageInfo;
  },

  savePageInfo: function(pageInfo) {
    var string = "({ url: '" + pageInfo.url + "', " +
                    "title: '" + this.encode(pageInfo.title) + "', " +
                    "refreshOnVisit: " + pageInfo.refreshOnVisit + ", " +
                    "refresh: " + pageInfo.refresh + "," +
                    "customImage: '" + this.encode(pageInfo.customImage) + "', " +
                    "customBackground: '" + pageInfo.customBackground + "', " +
                    "openIn: '" + pageInfo.openIn + "' })";

    this.prefs.setCharPref(pageInfo.id, string);
  },

  clearPageInfo: function(id) {
    try {
      this.prefs.deleteBranch(id);
    } catch(e) {}
  },

  getBoolPref: function(name) {
    try {
      return this.prefs.getBoolPref(name);
    } catch(e) {
      return false;
    }
  },

  setBoolPref: function(name, value) {
    this.prefs.setBoolPref(name, value);
  },

  getIntPref: function(name) {
    try {
      return this.prefs.getIntPref(name);
    } catch(e) {
      return 0;
    }
  },

  setIntPref: function(name, value) {
    this.prefs.setIntPref(name, value);
  },

  getCharPref: function(name) {
    try {
      return this.prefs.getCharPref(name);
    } catch(e) {
      return null;
    }
  },

  setCharPref: function(name, value) {
    this.prefs.setCharPref(name, value);
  },

  getFont: function() {
    return eval(this.prefs.getCharPref("font"));
  },

  setFont: function(family, size) {
    var font = "({ family: '" + family + "', " +
                 "size: " + size + " })";
    this.prefs.setCharPref("font", font);
  },
}
