function $(id) {
  return document.getElementById(id);
}

var FdUtils = {
  cloneObject: function(object) {
    var clone = new Object();
    for(var i in object) {
      clone[i] = object[i];
    }
    return clone;
  },

  clearElement: function(element) {
    for(var i = element.childNodes.length - 1; i >= 0; i--) {
      element.removeChild(element.childNodes[i]);
    }
  },

  confirm: function(message) {
    var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                  .getService(Components.interfaces.nsIPromptService);
    return prompts.confirm(window, $("fd-bundle").getString("fastDial"), message);
  },

  getHiddenWindow: function() {
    return Components.classes["@mozilla.org/appshell/appShellService;1"]
           .getService(Components.interfaces.nsIAppShellService)
           .hiddenDOMWindow;
  },

  getBrowserWindow: function() {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
             .getService(Components.interfaces.nsIWindowMediator);
    return wm.getMostRecentWindow("navigator:browser");
  },

  getFontList: function() {
    var enumerator = Components.classes["@mozilla.org/gfx/fontenumerator;1"]
                     .getService(Components.interfaces.nsIFontEnumerator);
    var count = {};
    return enumerator.EnumerateAllFonts(count);
  },

  isBlank: function(doc) {
    return doc && doc.location && doc.location.href == "about:blank";
  },

  forEachBlankPage: function(onPage) {
    var gBrowser = FdUtils.getBrowserWindow().getBrowser();
    for (var i = 0; i < gBrowser.browsers.length; i++) {
      var doc = gBrowser.browsers[i].contentDocument;
      if (FdUtils.isBlank(doc)) onPage(doc);
    }
  },

  isFirefox3: function() {
    return Components.classes["@mozilla.org/login-manager;1"];
  },

  isJavaEnabled: function() {
    return window.Packages;
  },

  getDocumentTab: function(doc) {
    var tabs = gBrowser.tabContainer.childNodes;
    for(var i = 0; i < tabs.length; i++) {
      if (tabs[i].linkedBrowser.contentDocument == doc) {
        return tabs[i];
      }
    }
  },

  openUILink: function(url, where) {
    if (where instanceof Event &&
        !where.shiftKey &&
        !where.ctrlKey)
    {
      where = (where.button == 1) ? "tabshifted" : "";
    }

    // Firefox
    if (window.openUILink) {
      if (!where || where instanceof Event) {
        return openUILink(url, where)
      }
      else return openUILinkIn(url, where);
    }

    // Else SeaMonkey
    if (where instanceof Event) {
      return openNewTabOrWindow(where, url);
    }
    switch(where) {
      case "tabshifted": return gBrowser.addTab(url);
      case "tab":        return gBrowser.selectedTab = gBrowser.addTab(url);
      case "window":     return openNewWindowWith(url);
      default:           return loadURI(url);
    }
  }
}
